//-----------------------------------------------------------------------------
/*
Programmed by Olivier Sangala
http://olivier.sangala.free.fr
olivier_sangala@hotmail.com
*/
//-----------------------------------------------------------------------------

// C Header File
// Created 08/09/02; 17:03:30

//-----------------------------------------------------------------------------

#define STATS_LEFT (128)
#define WIDTH_MAX (16)
#define HEIGHT_MAX (12)
#define MINE_NUM (9)
#define SMILEY_HEIGHT (26)

//-----------------------------------------------------------------------------

enum {TS_Hidden,TS_Mine,TS_Wonder,TS_Viewed,TS_MineShowed,TS_WrongMine,TS_MineShowedStart};
enum {TG_Playing,TG_Win,TG_Lose};


//-----------------------------------------------------------------------------

typedef struct
{
	int x;
	int y;
}
TPoint;

typedef struct
{
	char MinesAroundCount;
	char state;
}
TTile;

typedef struct
{
	TTile Tiles[30][30];
	
	int width;
	int height;
	int mines;
	int use_marks;
	
	int mines_counter;
	int viewed_counter;
	int game_state;
	int pos_x,pos_y;
	
	TPoint ZeroPoints[WIDTH_MAX*HEIGHT_MAX];
	int ZeroPointsCount;
	
}
TGame;

//-----------------------------------------------------------------------------

void InputStr (char *buffer, short maxlen);
void NewGame(void);
void RefreshTile(int x, int y);
void RefreshScreen(void);
void AddMine(int x, int y);
void RemoveMine(int x, int y);
void LeftClick(int x, int y);
void RightClick(int x, int y);
void RLClick(int x, int y);
void CorrectOptions(void);
int IsPointIntoMap(int x, int y);

void ZeroPointAround(int x, int y);
void ZeroPointAdd(int x, int y);
void ZeroPointExecute(int x, int y);

//-----------------------------------------------------------------------------
